#!/usr/local/python/bin/python
# -*- coding: latin-1 -*- 
#myDiary 4.3 by William Mensah - wilmens

####################################################
## SETUP THE ENVIRONMENT:
####################################################
import sys
import os
import time
import re
import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade
import shutil
import pango
import re
import gtkspell
import glob
import gobject
import urllib #used to retrive version info from website
import datetime
import webbrowser
#################################################


####################################################
### PULL IN THE GUI:
####################################################
appPath = os.path.realpath(os.path.dirname(sys.argv[0])) # get path to the application

guru = gtk.glade.XML(os.path.join(appPath, 'myDiary.glade'))	#guru has every GUI needed, all you have to do is get it.


#******************************************* MY CODE ************************************************


####################################################
### GLOBAL DEFINITIONS:
####################################################
mainWin = guru.get_widget('myDiary')
txtBlog = guru.get_widget('txtBlog').get_buffer()
txtSyncDetails = guru.get_widget('txtSyncDetails').get_buffer()
messageBox = guru.get_widget('customDialog')
okDialogBox = guru.get_widget('OkDialog')
lblDialogMsg = guru.get_widget('lblCustomMsg')
lblCurrDate = guru.get_widget('lblDate')
calendar = guru.get_widget('diaryCal')
statusBar = guru.get_widget('statusbar')
popup_menu = guru.get_widget('pop_menu')

# global variables
blogsPath = os.path.expanduser("~/myDiary/Blogs")
searchPhrase = ''
foundList = [] #stores dates from search results
searchOpt = "all blogs" # default search option - all blogs
colorTag = txtBlog.create_tag("bkcolor", background="yellow")
currFaceCapImg = ''
accessGranted = False 
UnrecognizedFile = ''
window_mode = "min" #default window mode


####################################################
### CUSTOM FUNCTIONS:
####################################################

#encryption / decryptions codes
#These take a string of text and return an encrypted or decrypted version of it.

def Encrypt(icText):
	icText = unicode(icText, "latin1")
	icChar = ""
	icNewText = ""
	icLen = len(icText)
	for i in range(0, icLen):
		icChar = icText[i:i+1] #equivalent to Mid() function in VB
		asciiVal = ord(icChar)
		icChar = chr(asciiVal-5)
		
		icNewText = icNewText + icChar

	return icNewText


def Decrypt(icText):
	icChar = ""
	icNewText = ""
	icLen = len(icText)
	dummyim = ""
	for i in range(0, icLen):
		icChar = icText[i:i+1] 
		asciiVal = ord(icChar)
		icChar = chr(asciiVal+5)		
		icNewText = icNewText + icChar
	return icNewText

# SYNCHRONIZATION ALGORITHM #########################################

def Sync():
	#attempt to get blog files on windows
	winDir = [] #directory on windows volume where blogs are stored
	winBlogs = [] #blogs saved on windows volume
	winBlogsPath = ""
	ubunBlogs = glob.glob(os.path.expanduser("~/myDiary/Blogs/[0-9]*.dat"))
	
	pBar = guru.get_widget('ProgressBar') #get holder for the progress bar
	
	pBar.set_fraction(0) #empty the progress bar
	txtSyncDetails.set_text("Sync started at "+ getCurrentTime()+"\n\t  ---------------\n")

	
	try:
		# try to find a path in some directory (*) in media that contains /myDiary/Blogs
		winDir = glob.glob("/media/*/myDiary/Blogs")

		if winDir != []: #volume has been detected so hide retry button and get all blog names.
			guru.get_widget('btnSyncRetry').set_property('visible', False)
			winBlogs = glob.glob(winDir[0]+"/[0-9]*.dat")
			# The regular expression [0-9]* makes blog get only file names starting with digits
			# and hence skipping Settings.dat and UserData.dat

			for x in winBlogs:
				# To get the full path (including windows volume name) of "../myDiary/Blogs", get
				# the first element in winBlogs, remove the file at the end and save the remaining path.
				winBlogsPath = os.path.split(x)[0]
				break
			
		else: # path was not found in /media
			guru.get_widget('lblSyncDialog').set_text("Synchronization Failed")
			start, end = txtSyncDetails.get_bounds() # bounds of sync details text box
			txtSyncDetails.insert(end, "Windows volume could not be detected.\nMake sure the volume is mounted or click on help for more information.")
			guru.get_widget('btnSyncOk').set_sensitive(True)
			guru.get_widget('btnSyncRetry').set_property('visible', True)
			return False
	except:
		print "Windows volume could not be detected. Make sure the volume is mounted."
		return False
	
	# Begin the Synchronization Process....
	start_time = time.time()
	
	#step1: If a file is in Linux & not in Windows, copy the file from Linux to Windows
	copyCount1 = 0
	for u_File in ubunBlogs:
		w_File = os.path.join(winBlogsPath, os.path.split(u_File)[-1]) #windows file
		pBar.pulse()
		if (os.path.isfile(u_File)) and (os.path.isfile(w_File)):
			#if the same file exists on both operating systems then do nothing
			pass
		else:
			#no match found so copy the file from Linux to windows
			shutil.copy2(u_File, winBlogsPath)
			copyCount1 += 1
			
	start, end = txtSyncDetails.get_bounds()
	txtSyncDetails.insert(end, "STEP 1/3: "+str(copyCount1)+" blog(s) copied from Linux to Windows.\n")

	#step2: If a file is in Windows & not in Linux, copy the file from Windows to Linux
	copyCount2 = 0
	for w_File in winBlogs:
		pBar.pulse()
		u_File = os.path.join(blogsPath, os.path.split(w_File)[-1]) #Linux file

		if (os.path.isfile(w_File)) and (os.path.isfile(u_File)):
			pass
		else:
			#no match found so copy the file from windows to Linux
			shutil.copy2(w_File, blogsPath)
			copyCount2 += 1
			
	start, end = txtSyncDetails.get_bounds()
	txtSyncDetails.insert(end, "STEP 2/3: "+str(copyCount2)+" blog(s) copied from Windows to Linux.\n")

	#step3: If the last-modified date of a Linux file is > than that of a windows file,
	#	replace the windows file with the Linux file, else replace the Linux file with the windows file

	ubunBlogs = glob.glob(os.path.expanduser("~/myDiary/Blogs/[0-9]*.dat")) 
	updateCount = 0
	for u_File in ubunBlogs:
		pBar.pulse()
		u_Time = os.stat(u_File).st_mtime # get last modification time of Linux file 'st_mtime'
		w_File = os.path.join(winBlogsPath, os.path.split(u_File)[-1]) #windows file
		w_Time = os.stat(w_File).st_mtime # get last modification time of windows file
		
		if (u_Time > w_Time): #greater than, that means u_Time was has the most recent modification
			# remove the file and copy the most recent one from Linux there
			# i guess over writing does the same thing, but i didn't want to do it that way.
			os.remove(w_File)
			shutil.copy2(u_File, winBlogsPath)
			updateCount += 1
			
		elif (u_Time < w_Time):	
			os.remove(u_File)
			shutil.copy2(w_File, blogsPath)
			updateCount += 1

	elapsed_time = round((time.time() - start_time), 2) 
	#rounds the elapsed time to 2 decimal places ie. round(float, #decima places)
	
	guru.get_widget('lblSyncDialog').set_text("Synchronization Complete")
	guru.get_widget('btnSyncOk').set_sensitive(True) # make the ok button sensitive.

	pBar.set_fraction(1.0) #fill the progress bar

	start, end = txtSyncDetails.get_bounds()
	
	txtSyncDetails.insert(end, "STEP 3/3: "+str(updateCount)+" blog(s) updated.\n\t  ---------------\nSync completed at "+ getCurrentTime()+"\nTotal time elapsed: "+str(elapsed_time)+" secs")

	# all done!! freakin' genius!
	return True


#####################################################################
def calcDirSize(arg, dir, files):
#calculates the size of a given directory
	try:
		# files to be excluded. Their sizes don't matter to us.
		files.remove("UserData.dat")
		files.remove("Settings.dat")
	except:
		pass
	
	for file in files:
		stats = os.stat(os.path.join(dir, file))
		size = stats[6] #stats[6] contains the file size information
		arg.append(size)


def getDirSize(dir):
#returns the size of a given directory.
#makes a call to calcDirSize()
	sizes = []
	os.path.walk(dir, calcDirSize, sizes)
	total = 0
	for size in sizes:
		total = total + size
	if total > 1073741824:
		return str(round(total/1073741824.0, 2))+'GB'
	if total > 1048576:
		return str(round(total/1048576.0, 2))+'MB'
	if total > 1024:
		return str(round(total/1024.0, 2))+'KB'

	return str(total)+" bytes"


def get_currBlogFile(): 
	# returns a path to the current blog by checking what the currently selected date is
	filename = formatFileName(lblCurrDate.get_text())+".dat"
	filepath = os.path.join(blogsPath,filename)
	return filepath


def show_okDialogBox(text): 
#shows ok dialog box and sets it's label to the text passed as a parameter
	guru.get_widget('lblOkDialogText').set_markup(text)
	okDialogBox.show()

def hide_okDialogBox():
	guru.get_widget('lblOkDialogText').set_text("")
	okDialogBox.hide()
	

def show_customDialog(title, label):
	#This function shows the custom dialog box and sets the label and title and icon
	#To set the icon, the function checks for the title of the custom message box is set to and
	#displays the appropriate icon
	messageBoxIcon = guru.get_widget('customMsgIcon')
	
	messageBox.set_title(title) # set the title
	lblDialogMsg.set_markup(label) # set the label

	if title == "Exit":
		messageBoxIcon.set_from_icon_name('gtk-quit',gtk.ICON_SIZE_BUTTON)
	elif title == "Delete Blog":
		messageBoxIcon.set_from_icon_name('gtk-delete',gtk.ICON_SIZE_BUTTON)
	elif title == "Reset Password" or title == "Password":
		messageBoxIcon.set_from_icon_name('gtk-dialog-authentication',gtk.ICON_SIZE_BUTTON)
	elif title == "Reset myDiary":
		messageBoxIcon.set_from_icon_name('gtk-clear',gtk.ICON_SIZE_BUTTON)
	elif title == "Synchronize":
		messageBoxIcon.set_from_icon_name('gtk-network',gtk.ICON_SIZE_BUTTON)
	else:
		messageBoxIcon.set_from_icon_name('gtk-help',gtk.ICON_SIZE_BUTTON)

	messageBox.show()


def hide_customDialog():
	#hides the custom dialog box and clears all texts (title & label)
	messageBox.hide()
	messageBox.set_title("")
	lblDialogMsg.set_text("")
	return True


def formatCalDate(date): 
	# date becomes a list containing 3 values
	# date[0] = year, date[1] = month , date[2] = day
	formattedDate = str(date[1]+1)+"/"+str(date[2])+"/"+str(date[0])
	
	#date[1] is incremented by 1 because calendar months starts from 0
	return formattedDate


def show_FindDialog():
	# simply displays the find dialog and clears its input box for new entry
	guru.get_widget('findDialog').show()
	guru.get_widget('txtFind').set_text("")
	


def open_Blog():
#function for loading the current blog into txtBlog
	global searchPhrase
	foundIndices = [] #stores indices of where searchPhrase is found in the current blog

	try:
		fileData = open(get_currBlogFile(), 'r')
		fileContents = Decrypt(fileData.read())		
		fileData.close()
		
		title = getTitle(fileContents) #attempt to get title of current blog
		if title != "n/a": 
			# if there was a title, then set it in the title field
			guru.get_widget('blogTitle').set_text(title)
			txtBlog.set_text(fileContents[(fileContents.find('}')+2):])
		else:
			# else set the title field to 'No Title'
			guru.get_widget('blogTitle').set_text("No Title")
			txtBlog.set_text(fileContents)
			

		#do highlighting if searchPhrase contains something
		if searchPhrase != '':
			if title != "n/a":
				#if there's a title, then we don't want to start marking indexes start from 0 because of the title's position in the file
				#so we skip 11 + length of title indices forward
				foundIndices = [match.start() for match in re.finditer(re.escape(searchPhrase.lower()), fileContents[(11+len(title)):].lower())]
			else:
				foundIndices = [match.start() for match in re.finditer(re.escape(searchPhrase.lower()), fileContents.lower())]
				

		if foundIndices != []:	#apply backcolor to these indices
			starting, ending = txtBlog.get_bounds()
			#remove any existing tags
			txtBlog.remove_tag(colorTag, starting, ending)
			
			for index in foundIndices:
				start = txtBlog.get_iter_at_offset(index)
				end = txtBlog.get_iter_at_offset(index+len(searchPhrase))
				txtBlog.apply_tag(colorTag, start, end)	

				#scroll to mark where match was found
				mark = txtBlog.create_mark("iter", txtBlog.get_iter_at_offset(foundIndices[0]))
				guru.get_widget('txtBlog').scroll_to_mark(mark, 0)
				txtBlog.delete_mark_by_name("iter")
				
		# make 'delete blog' menu active
		guru.get_widget('menuDelete_Blog').set_sensitive(True)
	except:
		# there's no blog for current date
		txtBlog.set_text("")
		guru.get_widget('blogTitle').set_text("No Title")
		guru.get_widget('menuDelete_Blog').set_sensitive(False)
		
	if foundIndices == [] and searchPhrase == '':
		statusBar_Pop(1)
		statusBar_Push("1", "Ready")
		
	elif foundIndices != [] and searchPhrase != '':
		try:
			statusBar_Pop(5) # remove any old status
			if len(foundIndices == 1):
				statusBar_Push("5", str(len(foundIndices))+" match found in current blog")
			else:
				statusBar_Push("5", str(len(foundIndices))+" matches found in current blog")
		except:
			# there was no old status to pop so just put the new one.
			if len(foundIndices)==1:
				statusBar_Push("5", str(len(foundIndices))+" match found in current blog")
			else:
				statusBar_Push("5", str(len(foundIndices))+" matches found in current blog")
				
	else:
		try:
			statusBar_Pop(6)
			statusBar_Push("6", "No matches found in current blog")
		except:
			statusBar_Push("6", "No matches found in current blog")
		

	
def formatFileName(filename):
#switches a filename say from "2/22/2008" to "2_22_2008" or vice versa
#so it can be used where appropriate. eg. 2_22_2008 will be for file naming.
	if ((filename.find('/'))<0):
		filename = filename.replace('_','/')
	else:
		filename = filename.replace('/','_')

	return filename



def createUserDir():
	try:
		os.makedirs(os.path.expanduser("~/myDiary/Blogs"))
	except:
		print("Unable create directory. Check read/write access to the home directory.")



def statusBar_Push(ctx_id, text): # push text onto status bar
	context_id = statusBar.get_context_id(ctx_id)
	statusBar.push(context_id,text)

def statusBar_Pop(ctx_id):# pop text from status bar
	statusBar.pop(ctx_id)


def count_Blogs():
	file_count = 0
	for root, dirs, files in os.walk(blogsPath):
		file_count += len(files)
	return file_count

def showBlogsCountStatus():
	#Displays on the status bar the number of blogs currently in the blogs directory
	count = count_Blogs()-2 # -2 because we want to exclude Settings.dat and UserData.dat
	try:
		statusBar_Pop(1)
	except:
		pass

	if count < 1:
		statusBar_Push("blogs_count", "You currently have no blogs")
	elif count == 1:
		statusBar_Push("blogs_count", "You currently have 1 blog")
	else:
		statusBar_Push("blogs_count", "You currently have "+str(count)+" blogs")


def getCurrentTime(): #returns the current time of the day
	myTime = str(time.strftime("%a, %d %b %Y %I:%M:%S %p"))
	myTime = myTime.split(' ')
	return myTime[4]+' '+myTime[5] #this spits out a string of the time and either am or pm


def updateBoldDates(): # bolds out dates that have blogs on the calendar
	global foundList # list of files that contain search phrase, if any
	dummyList = []
	try:
		statusBar_Pop(1)
	except:
		pass

	statusBar.push(1,"Loading...")

	calendar.clear_marks() # clear any existing marks

	year, month, day = calendar.get_date() # get calendar values

	# if any file in /Blogs has the same month and year value then bold out the day
	
	for root, dirs, files in os.walk(blogsPath):
		myFiles = files
	
	if foundList == []: #no search has been done so make every blog date bold
		for y in myFiles:
			#files to be avoided - modify this anytime you add a data file to the blogs path
			if str(y).find("Data")<0 and str(y).find("Settings")<0 and str(y).find("version")<0: #avoid the UserData.dat
				dummyList.append(y[:-4]) #and take out the file extension
				
	else:
		for y in foundList:
			dummyList.append(y[:-4]) #and take out the file extension
	currF = ""
	try:	
		for x in dummyList:
			currF = x
			dummy = x.split('_')
			# i used month+1 because the calendar months starts from 0
			if (int(dummy[0]) == month+1) and (int(dummy[2]) == year): #if the month and year match
				calendar.mark_day(int(dummy[1])) #then mark the day
	except:
		global UnrecognizedFile
		UnrecognizedFile = glob.glob(os.path.join(blogsPath, currF+"*"))[0] #get the first element
		show_customDialog("Unknown File", "Unsupported file encountered: <i>"+os.path.split(UnrecognizedFile)[1]+"</i>. Delete this file?\n<span font_desc='8.0'><b>note:</b> Leaving this file in the directory could cause some problems</span>")
		return 

	#update the status bar
	showBlogsCountStatus()
	


def save_Settings(font, faceCap):
	#this function saves the user settings for the current font of txtBlog
	#and the status of 'sync_on_exit' - whether it's checked or not
	#The settings are saved in Settings.dat

	sync_status = guru.get_widget('sync_on_exit').get_active()

	tempImg = "" #temporary stores face cap image location in settings file

	#if no font is specified, use the font from the original settings file
	if font == "":
		settingsFile = open(os.path.join(blogsPath, "Settings.dat"))
		userSettings = settingsFile.read()
		Settings = userSettings.split('|')
		settingsFile.close()
		font = Settings[0]
		
		#try to get the original image file location while the Settings file is still open
		try:
			tempImg = Settings[2]
		except:
			tempImg = ""
			
	if faceCap == "": # no face cap image was passed to the function so set it to the original
		faceCap = tempImg

	try: # overwrite Settings.dat with the new data
		settingsFile = os.path.join(blogsPath, "Settings.dat")
		fileToWrite = open(settingsFile, 'w')
		fileToWrite.write(str(font)+"|"+str(sync_status)+"|"+faceCap)
		fileToWrite.close()
	except:
		print "Error while saving user settings."
	

def searchSolCount(text):
#This function returns a list containing 3 elements
#1. the number of blogs containing the search phrase
#2. a list of paths to the files containing the search phrase
#3. a list containing file names (names only, not paths) to files containing the search phrase
	text = text.lower()
	count = 0
	foundFiles = [] #file names of found files
	fullPathSols = [] #full path to found files
	month, day, year = lblCurrDate.get_text().split('/')
	
	# glob to get a list of files we need to search thru. The list depends on the
	# search options specified by the user
	if searchOpt == "current blog":
		files = [get_currBlogFile()]
	elif searchOpt == "current month":
		sFile = str(month) + "_*_" + str(year) +".dat"
		files = glob.glob(os.path.join(blogsPath, sFile))
	elif searchOpt == "current year":
		sFile = "*_*_"+ str(year) + ".dat"
		files = glob.glob(os.path.join(blogsPath, sFile))
	else:
		files = glob.glob(os.path.join(blogsPath, "[0-9]*.dat"))
		
	#loop through the files
	for x in files:
		if os.path.isfile(x):
			blog = open(x)
			currText = Decrypt(blog.read())
			currText = currText.lower() #convert to lower to avoid case sensitivity
			blog.close()
		else:
			currText = ""
		if currText.find(text) > 0: # if the search phrase is found, add the current file to our new list
			count += 1
			fullPathSols.append(x)
			xdir, xfile = os.path.split(x)
			foundFiles.append(xfile)
			continue #next iteration in for loop
	return (count, fullPathSols, foundFiles)


def checkForUpdates():
	#check about dialog for file version
	current_version = guru.get_widget('lblVersionInfo').get_text()
	current_version = current_version.split(' ')
	version_number = current_version[1]

	try:
		#download currentversion file from website
		urllib.urlretrieve("http://www.wilmens.net/docs/latest_version_linux.dat", os.path.join(blogsPath, "latest_version_linux.dat"))
	
		#read the file and obtain the version latest version number from it
		latestVerFile = open(os.path.join(blogsPath, "latest_version_linux.dat"))
		latest_version = latestVerFile.read()
	
		#if the latest version number is greater than the one stored in the variable,
		if (float(latest_version) > float(version_number)):
			show_okDialogBox("A new release of myDiary - <b>version "+ str(float(latest_version)) +"</b> is available!")
		else:
			show_okDialogBox("You're running the latest version of myDiary - <b>version "+ version_number +"</b>")

		#delete the downloaded file
		os.remove(os.path.join(blogsPath, "latest_version_linux.dat"))
		#done!
	except:
		show_okDialogBox("Unable to connect to server. Check your Internet connection")
		
		
def BackupBlogs(path): 
#blogs will be backed up to path
	destination = os.path.join(path, "myDiary_Backup")
	try:
		if os.path.isdir(destination):
			shutil.rmtree(destination)

		os.makedirs(destination) #create the backup directory
		
		for x in glob.glob(os.path.join(blogsPath, "[0-9]*.dat")):
			shutil.copy2(x, destination)
		show_okDialogBox("Your blogs were backed up to '<i>"+ destination +"</i>'\n<span font_desc='8.0'><b>note:</b> Old backups in the same directory have been updated.</span>")
	except:
		show_okDialogBox("Backup was unsuccessful.\nMake sure the path '"+path+"' exists and is accessible")
		
def RestoreBlogs(path):
	files = glob.glob(os.path.join(path, "*"))
	try:
		for x in files:
			if x.find("UserData.dat") > 0 or x.find("Settings.dat") > 0:
				continue
			else:
				shutil.copy2(x, blogsPath)
				show_okDialogBox("Restore completed successfully!\n<span font_desc='8.0'><b>note:</b> Your password and settings have not been affected.</span>")
	except IOError, (errno, strerror):
		show_okDialogBox("Restore was unsuccessful!\nCheck the neccessary directories and their accessibility.")
		print "I/O error(%s): %s" % (errno, strerror)
	except:
		show_okDialogBox("Restore was unsuccessful!\nCheck the neccessary directories and their accessibility.")
		

def getDateFromPath(path):
#extracts the date from a file path name and returns it as a string
	date = os.path.split(path)[1]
	month, day, year = date.split('_')
	year = year[:-4]
	return month+'/'+day+'/'+year
	
	
def getTitle(fileContents):
# determines if data has a title (ie. :title::{ blah blah blah })
# if it does, it returns the title 'blah blah blah', otherwise it returns 'n/a'

	if fileContents[:9] == ':title::{': #if the first 9 characters = :title::{, then there might be a title
		return fileContents[9:fileContents.find('}')] #title is between current index and '}'
	else:
		return 'n/a' # no title

def cmpDatesFromPath(x, y):
#x an y will be paths to files, the dates will have to be extracted to be compared
	# get date part of file path
	x = os.path.split(x)[1]
	y = os.path.split(y)[1]
	
	# get date elements, month, day, year
	xm, xd, xy = x.split('_')
	ym, yd, yy = y.split('_')
	
	# crop the year to remove '.dat'
	xy = xy[:-4]
	yy = yy[:-4]
	
	#print xm, xd, xy, "- versus -", ym, yd, yy
	#compare the dates using strptime (%Y) allows the use of 2008 for example, instead of 08
	if (time.strptime(xm+" "+xd+" "+xy, "%m %d %Y") > time.strptime(ym+" "+yd+" "+yy, "%m %d %Y")):
		return True
	return False

def dateDifference(date1, date2):
	
	m1, d1, y1 = (int(x) for x in date1.split('/'))	
	m2, d2, y2 = (int(x) for x in date2.split('/'))

	date1 = datetime.date(y1, m1, d1)
	date2 = datetime.date(y2, m2, d2)
	return str((date2 - date1)).split(',')[0]


def generate_myLife(myLifePath):
#takes all blogs saved in the blogs folder, combines them into one big blog and saves it as hmtl
	fileList = glob.glob(blogsPath+"/[0-9]*.dat")
	try:
		sortedList = quicksort(fileList)
	except:
		print "Unable to process blogs. Process aborted!"
		
	try:
		#place the myDiary logo
		fileToWrite = open(myLifePath, 'w')
		fileToWrite.write("<div align='center'><img src='http://community.wvu.edu/~wwm001/wilmens/myDiary_mylogo.png' /><br>myLife as of "+ time.strftime("%a, %d %b %Y %H:%M:%S %p") +"</div><br>")
				
		for x in sortedList:
			fileData = open(x, 'r')
			fileContents = Decrypt(fileData.read())		
			fileData.close()
			
			fileDate = getDateFromPath(x)		
			title = getTitle(fileContents)
			if title != "n/a":
				#set up header
				fileToWrite.write("<br><p><h3><u><strong><font color='gray' >Date:</font> </strong> " + fileDate + "  -  <font color='gray'><strong>Title: </strong></font>" + title + "</i></h3></u>")
				whattowrite = fileContents[(11+len(title)):]
			else:
				#set up header
				fileToWrite.write("<br><p><h3><u><strong><font color='gray' >Date:</font> </strong>" + fileDate + "</i></h3></u>")
				whattowrite = fileContents

			#smileys
			whattowrite = whattowrite.replace("\n", "<br>")
			whattowrite = whattowrite.replace(":)", "<img src='http://community.wvu.edu/~wwm001/wilmens/smileys/smile.jpg' />")
			whattowrite = whattowrite.replace(":(", "<img src='http://community.wvu.edu/~wwm001/wilmens/smileys/sad.jpg' />")
			whattowrite = whattowrite.replace("8-)", "<img src='http://community.wvu.edu/~wwm001/wilmens/smileys/cool.jpg' />")
			whattowrite = whattowrite.replace("<3", "<img src='http://community.wvu.edu/~wwm001/wilmens/smileys/love.jpg' />")
			whattowrite = whattowrite.replace(":D", "<img src='http://community.wvu.edu/~wwm001/wilmens/smileys/laugh.jpg' />")
			whattowrite = whattowrite.replace(":-*", "<img src='http://community.wvu.edu/~wwm001/wilmens/smileys/kiss.jpg' />")
			fileToWrite.write(whattowrite + "</font></p>")
		
		fileToWrite.close()
	except:
		show_okDialogBox("Unable to save myLife. Try saving to a different location")
		
	show_okDialogBox("myLife was successfully saved to '<i>"+myLifePath+"</i>'")

def previous_blog():
	count = 0
	while True:
		count = count + 1
	
		#get current blog
		blogfile = get_currBlogFile()
		blogdate = formatFileName(getDateFromPath(blogfile))
		newdate = date_IncDec(blogdate, -1)
	
		#select the date on calendar
		newdate = newdate.split('_')
		calendar.select_month(int(newdate[1])-1, int(newdate[0]))
		calendar.select_day(int(newdate[2]))

		#if a blog exists, select the day and break else proceed with loop
		if searchPhrase == '':
			if (os.path.isfile(get_currBlogFile()) or count >= 60):
				if count >= 60:
					show_okDialogBox("Previous blog, if any, seems to be out of reach.")
					on_today_activate()
				break;
		else: #there was a search
			if (((getDateFromPath(get_currBlogFile()).replace('/', '_') + ".dat") in foundList) or count >= 60):
				if count >= 60:
					show_okDialogBox("Previous blog, if any, seems to be out of reach.")
					on_today_activate()
				break;			
				


def next_blog():
	global foundList
	count = 0
	while True:
		count = count + 1
	
		#get current blog
		blogfile = get_currBlogFile()
		blogdate = formatFileName(getDateFromPath(blogfile))
		newdate = date_IncDec(blogdate, 1)
	
		#select the date on calendar
		newdate = newdate.split('_')
		calendar.select_month(int(newdate[1])-1, int(newdate[0]))
		calendar.select_day(int(newdate[2]))
		

		#if a blog exists, select the day and break else proceed with loop
		if searchPhrase == '':
			if (os.path.isfile(get_currBlogFile()) or count >= 60):
				if count >= 60:
					show_okDialogBox("Next blog, if any, seems to be out of reach.")
					on_today_activate()
				break;
		else: #there was a search, so see if the selected date has a blog in the foundList
			if (((getDateFromPath(get_currBlogFile()).replace('/', '_') + ".dat") in foundList) or count >= 60):
				if count >= 60:
					show_okDialogBox("Next blog, if any, seems to be out of reach.")
					on_today_activate()
				break;			

def date_IncDec(inputdate, inputdays):
#increments or decrements a date
#example code was found at http://aspn.activestate.com/ASPN/Mail/Message/wxPython-users/2837246
	from datetime import date, timedelta
	tmp = inputdate.split('_')
	calc = date(int(tmp[2]), int(tmp[0]), int(tmp[1]))
	calc += timedelta(days=inputdays)
	outputdate = calc.isoformat()
	return outputdate.replace('-', '_')
	
		
#++++++++++++++++++++++++++++++++ QUICK SORT ALGORITHM ++++++++++++++++++++++++++++++++++++++++
# A sweet Quicksort Written by Magnus Lie Hetland
# I made some changes to the algorithm to make it work with my type of list (a list of filepaths that have dates in 'em)
# The goal is to sort the dates at the end of the file paths in chronological order
# I used my cmpDatesFromPath() function for comparison

def _partition(list, start, end):
    pivot = list[end]
    bottom = start-1
    top = end

    done = 0
    while not done:

        while not done:
            bottom = bottom+1

            if bottom == top:
                done = 1
                break

            if cmpDatesFromPath(list[bottom], pivot): #pivot < list[bottom]:
                list[top] = list[bottom]
                break

        while not done:
            top = top-1
            
            if top == bottom:
                done = 1
                break

            if cmpDatesFromPath(pivot, list[top]): #list[top] < pivot:
                list[bottom] = list[top]
                break

    list[top] = pivot
    return top


def _quicksort(list, start, end):
	if start < end:
		split = _partition(list, start, end)
		_quicksort(list, start, split-1)
		_quicksort(list, split+1, end)
		
	return list

def quicksort(list):
    if len(list) > 1:
        return _quicksort(list, 0, len(list)-1)
       
        
#++++++++++++++++++++++++++++++ END ++++++++++++++++++++++++++++++++++++++++++++++++
	
	

## INITIALIZATIONS ########################
# read password file.
# if it exists, store what the password is
# else, it's a new user so prompt for new password and save it
userPsswd = ""
try:
	psswdFile = open(os.path.join(blogsPath,"UserData.dat"))
	userPsswd = Decrypt(psswdFile.read())
	psswdFile.close()
	updateBoldDates()
except : #file doesn't exist so save it
	guru.get_widget('lblLoginInfo').set_text("Welcome! Please set a password.")


currDate = formatCalDate(calendar.get_date())
lblCurrDate.set_text(currDate) #display current date in label

#call open blog
open_Blog()

#get user settings
Settings = []
try:
	settingsFile = open(os.path.join(blogsPath, "Settings.dat"))
	userSettings = settingsFile.read()
	Settings = userSettings.split('|') 
	settingsFile.close()

	#now set the font in the textbox and set sync on exit status
	text_font = Settings[0]
	guru.get_widget('txtBlog').modify_font(pango.FontDescription(text_font))
	guru.get_widget('blogTitle').modify_font(pango.FontDescription(text_font.split(' ')[0] + " italic " + text_font.split(' ')[1]))
	if Settings[1] == 'True':
		guru.get_widget('sync_on_exit').set_active(1)
	else:
		guru.get_widget('sync_on_exit').set_active(0)

	if Settings[2] != "" and os.path.isfile(Settings[2]):
		guru.get_widget('img_FaceCap').set_from_file(Settings[2])
		currFaceCapImg = Settings[2]
	else: #display a stock image
		#guru.get_widget('img_FaceCap').set_from_stock('gtk-file',gtk.ICON_SIZE_BUTTON)
		currFaceCapImg = ''
		
except:
	#new user so probably there's no settings file.
	#so set the font for the blog editor and face cap image to default
	guru.get_widget('txtBlog').modify_font(pango.FontDescription("Sans 10"))
	guru.get_widget('blogTitle').modify_font(pango.FontDescription("Sans 10"))
	currFaceCapImg = ''


#show number of blogs
showBlogsCountStatus()


#*****************************************************************************

def save_Blog(): 
	# saves whatever is in the current blog by overwriting the old file.
#This function calls both updateBoldDates and showBlogsCountStatus, so any caller to save_Blog() 
#doesn't have to call those 2 functions.
	try:
		currData = txtBlog.get_text(*txtBlog.get_bounds()) # get what's in the text box
		currFile = get_currBlogFile()
		blogTitle = guru.get_widget('blogTitle').get_text() #blog title
		
		if blogTitle != "No Title" and blogTitle != "":
			#doing some restriction to avoid errors
			blogTitle = blogTitle.replace('{', '(')
			blogTitle = blogTitle.replace('}', ')')
			currData = ":title::{" + blogTitle + "}\n" + currData #add the tile format to the blog data to be saved
			
		currData = Encrypt(currData)
		if currData != "":
			fileToWrite = open(currFile, 'w')
			fileToWrite.write(currData)
			fileToWrite.close()
			updateBoldDates()
		elif currData == "" and os.path.isfile(get_currBlogFile()):
			#remove the file
			os.remove(get_currBlogFile())
			updateBoldDates()
	except:
		print "An unexpected error occured while saving blog."

####################################################
### CREATE SIGNAL HANDLERS:
####################################################

#~~~~~~~~~~~ LOGIN DIALOG ITEMS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

def on_loginDialog_delete_event(*args): #login window is terminated
	gtk.main_quit()

#filter face cap selection so only images can be picked.
def on_menuFace_Caps_activate(*args):
	fcDialog = guru.get_widget('FaceCapChooser')
	#set filters	
	myfilter = gtk.FileFilter()
	myfilter.set_name("Images")
	myfilter.add_mime_type("image/png")
	myfilter.add_mime_type("image/jpeg")
	myfilter.add_mime_type("image/gif")
	myfilter.add_pattern("*.png")
	myfilter.add_pattern("*.jpg")
	myfilter.add_pattern("*.gif")
	myfilter.add_pattern("*.tif")
	myfilter.add_pattern("*.xpm")
	fcDialog.add_filter(myfilter)
	fcDialog.show()

def on_backup_activate(*args):
	chooser = gtk.FileChooserDialog(title='Backup to...',action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
                                  buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
	chooser.set_current_folder(os.path.expanduser("~/Documents"))
	response = chooser.run()
	if response == gtk.RESPONSE_OK:
		BackupBlogs(chooser.get_filename())
	chooser.destroy()
	
def on_restore_activate(*args):
	show_customDialog("Restore", "Are you sure you want to restore your blogs?\n\n<span font_desc='8.0'><b>note:</b> Current blogs will be overwritten</span>")

def on_btnLoginOk_clicked(*args):
	# This function handles what happens when the user clicks on the
	# ok button of the login dialog

	#get user input from text box named: txtPsswd
	#value from text box is obtained by get_text() and stored in psswdEntered
	psswdEntered = guru.get_widget('txtPsswd').get_text()

	#processing for new user
	if (str(guru.get_widget('lblLoginInfo').get_text()).find("Please set a password") > 0) and (psswdEntered != "") :	
		#confirm password
		show_customDialog("Password", "Your password will be set to '"+psswdEntered+"'. Accept?")
	else:
		#verify password
		if (psswdEntered == userPsswd):
			save_Settings("", currFaceCapImg)
			guru.get_widget('loginDialog').hide()
			mainWin.show()
		else:
			guru.get_widget('lblLoginInfo').set_text("Invalid Password!")



def on_btnLoginCancel_clicked(*args): #login is cancelled
	show_customDialog("Exit", "Are you sure you want to exit?")




def on_menuLogin_About_activate(*args): #show About dialog
	guru.get_widget('aboutDialog').show()



def on_menuLogin_Quit_activate(*args): #quit is chosen from login menu
	show_customDialog("Exit", "Are you sure you want to exit?")




#~~~~~~~   MAIN WINDOW ITEMS: ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

def on_myDiary_destroy(*args):
	save_Blog()
	save_Settings("", currFaceCapImg) #no font was specified so the original font and face cap will be used

	#check if blogs must be syncrhonized
	if guru.get_widget('sync_on_exit').get_active(): #then synchronize
		guru.get_widget('syncDialog').show()
		if Sync(): #if Sync() returns true, it means synchronization was successful so just exit
			gtk.main_quit()
	else:
		gtk.main_quit()

def on_btnTime_clicked(*args):
	myTime = getCurrentTime()
	txtBlog.insert_at_cursor(myTime)
	save_Blog()


def on_btnFind_clicked(*args):
	show_FindDialog()



def on_btnRefresh_clicked(*args):
	global searchPhrase
	searchPhrase = ''
	global foundList
	foundList = []
	starting, ending = txtBlog.get_bounds()
	txtBlog.remove_tag(colorTag, starting, ending)
	save_Blog()
	updateBoldDates()

def on_btnBack_clicked(*args):
	save_Blog()
	previous_blog()

def on_btnNext_clicked(*args):
	save_Blog()
	next_blog()


#~~~~~~~~~~~~ MENU ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ actions performed from main menu

def on_my_life_activate(*args):
	show_customDialog("myLife", "Would you like to save a compilation of all your blogs?\n\n<span font_desc='8.0'><b>note:</b> <i>myLife</i> is neither password protected nor encrypted</span>")

def on_calculator_activate(*args):
	guru.get_widget('Calculator').show()
	currDate = time.localtime()
	#set date1's text to today's date as default
	guru.get_widget('selDate2').set_active(True)
	guru.get_widget('calcDate1').set_text(str(currDate[1]) + '/' + str(currDate[2]) + '/' + str(currDate[0])) #currDate = yyyy, mm, dd
	guru.get_widget('calcDate2').set_text(lblCurrDate.get_text())


def on_today_activate(*args): #goto today
	save_Blog()
	currDate = time.localtime()
	calendar.select_month(int(currDate[1])-1, int(currDate[0]))
	calendar.select_day(int(currDate[2]))

	try:
		statusBar_Pop(7)
		statusBar_Push("7", "Today is "+time.strftime("%a, %d %b %Y %H:%M:%S %p"))
	except:
		statusBar_Push("7", "Today is "+time.strftime("%a, %d %b %Y %H:%M:%S %p"))

#navigate
def on_next_activate(*args):
	save_Blog()
	next_blog()

def on_previous_activate(*args):
	save_Blog()
	previous_blog()

def on_menuTime_activate(*args): #insert time
	save_Blog()
	myTime = getCurrentTime()
	txtBlog.insert_at_cursor(myTime)



def on_menuRefresh_activate(*args): #refresh calendar
	global searchPhrase
	searchPhrase = '' #reset searchPhrase
	global foundList
	foundList = [] #reset foundList
	#remove all tags
	starting, ending = txtBlog.get_bounds()
	txtBlog.remove_tag(colorTag, starting, ending)
	save_Blog()



def on_quit1_activate(*args): #terminate application
	save_Blog()
	show_customDialog("Exit", "Are you sure you want to exit?")	



def on_delete_blog1_activate(*args): #delete current blog
	show_customDialog("Delete Blog", "Are you sure you want to delete this blog dated '"+lblCurrDate.get_text()+"'?")


def on_lock_activate(*args): #lock...
	global accessGranted
	save_Blog()
	mainWin.hide()
	accessGranted = False
	guru.get_widget('txtPsswd').set_text("")
	guru.get_widget('lblLoginInfo').set_text("Locked.")
	guru.get_widget('loginDialog').show()

def on_menuFind_activate(*args): #find...
	save_Blog()
	show_FindDialog()

def on_spell_check_activate(*args): #spell check
	if guru.get_widget('spell_check').get_active():
		gtkspell.Spell(guru.get_widget('txtBlog'))
		statusBar_Push("3", "Spell-Checking: ON")
	else:
		myspell = gtkspell.get_from_text_view (guru.get_widget('txtBlog'))
            	myspell.detach ()
		statusBar_Pop(3)
		statusBar_Push("3", "Spell-Checking: OFF")

def on_switch_mode_activate(*args): #switch mode
		global window_mode

		if (window_mode == "min"):
			#if window is in normal mode ('min') then maximize it
			guru.get_widget('calnFind').hide()
			window_mode = "max"
		else:
			#else put it in normal mode
			guru.get_widget('calnFind').show()
			window_mode = "min"
	

def on_menu_sync_activate(*args): #sync...
	show_customDialog("Synchronize", "Would you like to synchronize your blogs?")



def on_menuChange_Font_activate(*args):
	guru.get_widget('fontSelDialog').show()
	try: #try to get the name of the current font from the settings file and set it on the dialog box
		settingsFile = open(os.path.join(blogsPath, "Settings.dat"))
		userSettings = settingsFile.read()
		Settings = userSettings.split('|') 
		settingsFile.close()
		text_font = Settings[0]
		guru.get_widget('fontSelDialog').set_font_name(text_font)
	except:
		pass



def on_menuReset_Psswd_activate(*args): #reset password
	show_customDialog("Reset Password", "Are you sure you want to reset your password?")



def on_menuReset_myDiary_activate(*args): #reset myDiary
	show_customDialog("Reset myDiary", "Do you really want to reset myDiary?\n\n<span font_desc='8.0'><b>Caution:</b> All saved data will be permanently erased in the process.</span>")

def on_menuContents_activate(*args):
	guru.get_widget('Contents').show()

def on_check_for_updates_activate(*args):
	checkForUpdates()

def on_menuAbout_activate(*args): #about
	guru.get_widget('aboutDialog').show()



#~~~~~~~~~~~ ABOUT DIALOG ITEMS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_aboutDialog_show(*args):
	guru.get_widget('lblSizeWorth').set_text("Total size of blogs: "+str((getDirSize(blogsPath+"/"))))


def on_aboutDialog_delete_event(*args): #when x-button is pressed
	guru.get_widget('aboutDialog').hide()
	return True

def on_btnClose_About_clicked(*args): # when close button is clicked
	guru.get_widget('aboutDialog').hide()

def on_btnURL_clicked(*args):
	# open url in user's default browser.
	webbrowser.open_new_tab("http://www.wilmens.net")


#~~~~~~~~~~ MESSAGE BOX DIALOG ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

def on_customDialog_delete_event(*args): #action taken when messageBox is closed with the x-button
	hide_customDialog()
	return True



def on_btnCustomDialog_Yes_clicked(*args):
	# This function is called whenever the "yes" button is clicked on the custom dialog
	# A number of things happen at this point, depending on what the title of the 
	# custom dialog box is.
	global accessGranted

	msgCaller = messageBox.get_title() #get what the title of the dialog box says - who called the messageBox
	hide_customDialog()

	if msgCaller == "Exit":
		save_Blog()
		save_Settings("", currFaceCapImg) #no font was specified so the original font and face cap will be used

		#check if blogs must be syncrhonized
		if guru.get_widget('sync_on_exit').get_active() and accessGranted == True: #then synchronize
			guru.get_widget('syncDialog').show()
			if Sync(): #if Sync() returns true, it means synchronization was successful so just exit
				gtk.main_quit()
		else:
			gtk.main_quit()

	elif msgCaller == "Reset Password":
		try:
			os.remove(os.path.join(blogsPath,"UserData.dat")) #delete the password file
			show_okDialogBox("Your password has been reset. Please restart the application.")
		except:
			statusBar_Push("reset_psswd_failure", "Unable to reset password")


	elif msgCaller == "Reset myDiary": #deletes the myDiary folder
		try:
			shutil.rmtree(os.path.expanduser("~/myDiary"))
			show_okDialogBox("myDiary has been reset. Please restart the application.")
		except:
			statusBar_Push("reset_myDiary_fail", "Unable to reset myDiary")


	elif msgCaller == "Delete Blog":
		try:
			os.remove(get_currBlogFile()) #gets the path of the current blog and deletes it
			open_Blog()
			updateBoldDates()
			statusBar_Push("delete_blog", "Blog has been deleted")
			
		except:
			statusBar_Push("delete_blog_fail", "Unable to delete blog")


	elif msgCaller == "Synchronize":
		save_Blog()
		guru.get_widget('syncDialog').show()
		Sync()

	elif msgCaller == "Password":
		createUserDir()
		tempfile = open(os.path.join(blogsPath,"UserData.dat"), 'w')
		userPsswd = guru.get_widget('txtPsswd').get_text()
		tempfile.write(Encrypt(userPsswd))
		tempfile.close()
		
		if os.path.isfile(os.path.join(blogsPath, "Settings.dat")):
			pass
		else:
			tempfile = open(os.path.join(blogsPath,"Settings.dat"), 'w')
			tempfile.write("Sans 11|False")
			tempfile.close()
			
		guru.get_widget('loginDialog').hide()
		updateBoldDates()
		mainWin.show()
		accessGranted = True
		
	elif msgCaller == "Restore":
		chooser = gtk.FileChooserDialog(title='Restore From...',action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
                                  buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
		chooser.set_current_folder(os.path.expanduser("~/Documents"))
		response = chooser.run()
		if response == gtk.RESPONSE_OK:
			RestoreBlogs(chooser.get_filename())
		chooser.destroy()
		
	elif msgCaller == "myLife":	
		while 1: #terrible code, but i was screwed....loops till a directory is chosen where the file doesn't already exist
			chooser = gtk.FileChooserDialog(title='Save myLife to...',action=gtk.FILE_CHOOSER_ACTION_SAVE,
            	                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
			chooser.set_current_name("myLife.html")
			chooser.set_current_folder(os.path.expanduser("~/Documents"))
			response = chooser.run()
			filename = chooser.get_filename()
			
			if response == gtk.RESPONSE_OK:
				if os.path.isfile(filename):
					box=gtk.MessageDialog(messageBox,gtk.DIALOG_DESTROY_WITH_PARENT,
						gtk.MESSAGE_QUESTION,gtk.BUTTONS_YES_NO,
						"'"+filename+"' already exists; do you want to overwrite it?")
					ans=box.run()
					box.hide()
					if ans==gtk.RESPONSE_YES: #proceed with overwrite and break the loop
						chooser.destroy()
						generate_myLife(filename)
						break
					elif ans == gtk.RESPONSE_NO:
						chooser.destroy()
				else:
					#file does not already exist -> break the loop
					chooser.destroy()
					generate_myLife(filename)
					break
				
			elif response == gtk.RESPONSE_CANCEL: # -> user doesn't want to save anymore -> break the loop
				chooser.destroy()
				break	
	elif msgCaller == "Unknown File":
		global UnrecognizedFile
		if UnrecognizedFile != '':
			try:
				os.remove(UnrecognizedFile)
				show_okDialogBox("The unrecognized file '<i>"+os.path.split(UnrecognizedFile)[1]+"</i>' was successfully removed.\n<span font_desc='8.0'><b>note:</b>If this problem persists, try backing up blogs and reset myDiary.</span>")
			except:
				print "Unable to remove the file '"+UnrecognizedFile+"'. Try manually removing the file in the path specified."
				show_okDialog("Unable to remove the file.")
		UnrecognizedFile = ''
				
	else :
		print "authorization caller unidentified"


def on_btnCustomDialog_No_clicked(*args):
	#hides the exit dialog box when no is clicked
	hide_customDialog()


#~~~~~~~~~~~~~~~ OK DIALOG BOX ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_OkDialog_delete_event(*args):
	save_Blog()
	lbltext = guru.get_widget('lblOkDialogText').get_text()
	if lbltext.find("restart") > 0:
		gtk.main_quit()
	else:
		hide_okDialogBox()
		return True

def on_btnOkDialog_clicked(*args): #when the ok button is clicked
	save_Blog()
	lbltext = guru.get_widget('lblOkDialogText').get_text()
	if lbltext.find("restart") > 0:
		gtk.main_quit()
	else:
		hide_okDialogBox()


#~~~~~~~~~~~~~~~  FIND DIALOG ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

def on_findDialog_delete_event(*args): # when x-button is pressed
	guru.get_widget('findDialog').hide()
	return True


def on_btnFind_Ok_clicked(*args): # when ok button is pressed
	global searchPhrase
	global foundList
	searchBox = guru.get_widget('txtFind')
	searchPhrase = searchBox.get_text()
	resultInfo = ""
	if searchPhrase != '':
		foundCount, foundPaths, foundList = searchSolCount(str(searchPhrase))
		guru.get_widget('findDialog').hide()
		if foundCount > 0:
			if searchOpt == "current blog":
				resultInfo = "The current blog contains one or more instances of '"+str(searchPhrase)+"'"
			elif searchOpt == "current month":
				resultInfo = str(foundCount)+" blog(s) in the currently selected month contain '"+str(searchPhrase)+"'"
			elif searchOpt == "current year":
				resultInfo = str(foundCount)+" blog(s) in the currently selected year contain '"+str(searchPhrase)+"'"
			else:
				resultInfo = str(foundCount)+" blog(s) found containing '"+str(searchPhrase)+"'"
			
			show_okDialogBox(resultInfo+".\n\n<span font_desc='8.0'><b>note:</b> Bold date(s) on the calendar indicate search results.\nUse CTRL+Right/Left to nagivate through results.</span>")
			if foundCount != 1:
				sortedList = quicksort(foundPaths) # sort the list of found dates
				lastDate = os.path.split(sortedList[-1])[1] # split the last path and take the date part of it eg. 2/2/2002.dat
			else:
				lastDate = foundList[0]
			date = lastDate.split('_')
			# date[0] = month, date[1] = day, date[2] = year (probably with '.dat' at the end)
			calendar.select_month(int(date[0])-1, int(date[2][:-4]))
			calendar.select_day(int(date[1])) #select the last date found
		else:
			show_okDialogBox("Sorry, '"+str(searchPhrase)+"' was not found.")
			searchPhrase = ''
			foundList = []
	updateBoldDates()
	open_Blog()



def on_btnFind_Cancel_clicked(*args): # when cancel button is pressed
	guru.get_widget('findDialog').hide()



#~~~~~~~~~~~~~ SYNC DIALOG ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
def on_syncDialog_delete_event(*args):
	guru.get_widget('syncDialog').hide()
	return True


#~~~~~~~~~~~ CALENDAR ACTIONS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_diaryCal_daySelected(*args):
	currDate = formatCalDate(calendar.get_date())
	lblCurrDate.set_text(currDate) #set the date label to the current date
	open_Blog() #Open blog for the current date

	#if the calculator is visible, check which radio button is selected and update the date text box
	if guru.get_widget('Calculator').get_property('visible') == True:
		if guru.get_widget('selDate1').get_active():
			guru.get_widget('calcDate1').set_text(lblCurrDate.get_text())
		elif guru.get_widget('selDate2').get_active():
			guru.get_widget('calcDate2').set_text(lblCurrDate.get_text())

def on_diaryCal_month_changed(*args):
	updateBoldDates()


#~~~~~~~~~~  FONT SELECTION DIALOG ACTIONS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_fontSelDialog_delete_event(*args): #when x-button on font dialog is pressed
	guru.get_widget('fontSelDialog').hide()
	return True

def on_btnfontSel_Cancel_clicked(*args): #when cancel is clicked on the fonts dialog
	guru.get_widget('fontSelDialog').hide()

def on_btnfontSel_Ok_clicked(*args):
	text_font = guru.get_widget('fontSelDialog').get_font_name()
	#the following line of code changes the font for the textbox
	guru.get_widget('txtBlog').modify_font(pango.FontDescription(text_font))
	guru.get_widget('blogTitle').modify_font(pango.FontDescription(text_font.split(' ')[0] + " italic " + text_font.split(' ')[1]))
	save_Settings(text_font, currFaceCapImg )
	guru.get_widget('fontSelDialog').hide()

def on_btnfontSel_Apply_clicked(*args):
	text_font = guru.get_widget('fontSelDialog').get_font_name()
	guru.get_widget('txtBlog').modify_font(pango.FontDescription(text_font))
	guru.get_widget('blogTitle').modify_font(pango.FontDescription(text_font.split(' ')[0] + " italic " + text_font.split(' ')[1]))
	



#~~~~~~~~~ TEXT VIEW EVENTS for txtBlog ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_txtBlog_focus_out_event(*args): #saves everytime the textbox loses focus
	save_Blog()
	
def on_blogTitle_focus_out_event(*args):
	save_Blog()

#~~~~~~~~ CONTENTS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_Contents_delete_event(*args):
	guru.get_widget('Contents').hide()
	return True

#~~~~~~~ SYNC DIALOG ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_syncDialog_delete_event(*args):
	guru.get_widget('syncDialog').hide()
	try:
		guru.get_widget('sync_on_exit').get_active()
		#if this goes through, then it means the main window is still open
	except:
		gtk.main_quit()

	return True

def on_btnSyncOk_clicked(*args):
	guru.get_widget('syncDialog').hide()
	try:
		guru.get_widget('sync_on_exit').get_active()
		#if this goes through, then it means the main window is still open
	except:
		gtk.main_quit()

	return True

def on_btnSyncHelp_clicked(*args):
	guru.get_widget('Contents').show()
	#scroll to mark
	help = guru.get_widget('helpText')
	help.scroll_to_iter(help.get_buffer().get_iter_at_line(68), 0)

def on_btnSyncRetry_clicked(*args):
	Sync()

#~~~~~~ HELP CONTENTS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_btnHelpClose_clicked(*args):
	guru.get_widget('Contents').hide()
	return True

#~~~~~~ DATE CALCULATOR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_Calculator_delete_event(*args):
	guru.get_widget('Calculator').hide()
	return True

def on_btnCopyCalcRes_clicked(*args):
	clipboard = gtk.clipboard_get()
	clipboard.set_text(guru.get_widget('lblcalcRes').get_text()[6:])
	clipboard.store() #make available to other applications

def on_btnCalcClose_clicked(*args):
	guru.get_widget('Calculator').hide()
	return True

def on_calcDate1_changed(*args):
	res = '...is n/a'
	#if the text has changed then update the results
	if guru.get_widget('calcDate1').get_text() != '' and guru.get_widget('calcDate2').get_text() != '':
		if guru.get_widget('calcDate1').get_text() != guru.get_widget('calcDate2').get_text():
			res = '...is ' + dateDifference(guru.get_widget('calcDate1').get_text(), guru.get_widget('calcDate2').get_text())
		else:
			res = '...is 0 days'
	guru.get_widget('lblcalcRes').set_text(res)
			

def on_calcDate2_changed(*args):	
	res = '...is n/a'
	#if the text has changed then update the results
	if guru.get_widget('calcDate1').get_text() != '' and guru.get_widget('calcDate2').get_text() != '':
		if guru.get_widget('calcDate1').get_text() != guru.get_widget('calcDate2').get_text():
			res = '...is ' + dateDifference(guru.get_widget('calcDate1').get_text(), guru.get_widget('calcDate2').get_text())
		else:
			res = '...is 0 days'
	guru.get_widget('lblcalcRes').set_text(res)


#~~~~~~~~ FACE CAP CHOOSER ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
def on_FaceCapChooser_delete_event(*args):
	guru.get_widget('FaceCapChooser').hide()
	return True

def on_btnFaceCapOpen_clicked(*args):
	global currFaceCapImg
	currFaceCapImg = guru.get_widget('FaceCapChooser').get_filename()
	guru.get_widget('img_FaceCap').set_from_file(currFaceCapImg)
	guru.get_widget('FaceCapChooser').hide()
	guru.get_widget('lblLoginInfo').set_text("Enter password to save changes to Face Cap.")
	return True

def on_btnFaceCapCancel_clicked(*args):
	guru.get_widget('FaceCapChooser').hide()
	return True


def on_radioFind_currBlog_clicked(*args):
	global searchOpt
	searchOpt = "current blog"
	
	
def on_radioFind_currMonth_clicked(*args):
	global searchOpt
	searchOpt = "current month"
	
	
def on_radioFind_currYear_clicked(*args):
	global searchOpt
	searchOpt = "current year"
	
def on_radioFind_allBlogs_clicked(*args):
	global searchOpt
	searchOpt = "all blogs"

	
	

#*****************************************************************************************************

####################################################
### CONNECT SIGNALS TO OUR HANDLERS:
####################################################
guru.signal_autoconnect(locals())

####################################################
### START UP THE PROGRAM:
####################################################
gtk.main()


